<?PHP

function tfheader_build_cache($full_extended_list=array(), $time_limit=9999)
{
 global $MyToppies, $RECservers, $local_files, $this_file_has_been_moved, $extended_desc_log ;
 global $FTPuser, $FTPpw, $FTPaddress, $FTPport, $FTPtype ;
 
 $display_status = ini_get("display_errors") ;
 ini_set("display_errors",0) ;
 
 echo "<!-- ";echo "Build extended cache (limit=$time_limit)";echo "-->\n" ;
 
 $t_start = time() ; // Make note of the time started
 if ($extended_desc_log) { $fp = fopen($local_files.DIRECTORY_SEPARATOR."extended_cache.log","a") ; }
 //$fp = fopen("null:","a") ;
 //fwrite($fp,"".date("Ymd H:i:s")." Cache run started".PHP_EOL) ;
 
 //echo "Moved " ; print_r($this_file_has_been_moved) ;
 
 $serverlist = array_merge($MyToppies,$RECservers) ;
 foreach($serverlist as $servername) 
 {			
    echo "<!-- ";echo "Build extended cache for $servername";echo " -->\n" ;
    $cache[$servername] = unserialize(file_get_contents($local_files.DIRECTORY_SEPARATOR.$servername."_extended_cache")) ;
		if (!is_array($cache[$servername])) { $cache[$servername] = array() ; }
    //echo "<!-- ";print_r($cache[$servername]);echo " -->\n" ;
		
		//echo "$servername " ;
		//print_r($cache) ;
		
		// Have we been notifiled of any moved files?
		//if (is_array($this_file_has_been_moved)) 
    if (is_array($this_file_has_been_moved))
    {
     foreach ($this_file_has_been_moved as $moved_file )
	   {
		  //echo "$servername " ; print_r($moved_file); echo "\n" ; print_r($cache[$servername]["events"][$moved_file["old_name"]]) ;
	    if ( $moved_file["server"]==$servername and is_array($cache[$servername]["events"][$moved_file["old_name"]]) )
	    {
	     $cache[$servername]["events"][$moved_file["new_name"]] = $cache[$servername]["events"][$moved_file["old_name"]] ;
			 if ($extended_desc_log) { fwrite($fp,"".date("Ymd H:i:s")." Cache moved to $servername".$moved_file["new_name"]." from ".$moved_file["old_name"].PHP_EOL) ; }
	    }
	   }
    }
    
		//if ($servername=="BlackSlug") { continue ; }
    if ( server_in_use($servername) ) { continue ; }  // this server is not available
 
    //if($FTPtype[$servername]=="ftp4t") { continue; }  // skip if ftp4t - response is too slow
		if ( !is_array( $extended_list=$full_extended_list[$servername] ) ) { continue ; }  // skip if there is no file list
		
		// make sure a test file is present
		ini_set("display_errors",0) ;
		$test_string = "ftp://".$FTPuser[$servername].":".$FTPpw[$servername]."@".$FTPaddress[$servername].":".$FTPport[$servername]."/toppywebtest.txt" ;
		if (file_get_contents($test_string)===false) { file_put_contents($test_string,"test - ignore") ; }
		ini_set("display_errors",1) ;
		
    //print_r($extended_list) ;
		// First add the cache entry for any new files
    foreach ($extended_list as $filename => $file_string)	
	  {
		  if (is_array($cache[$servername]["events"][$filename])) { continue ; }  // skip if a cache entry already exists
			//echo time()." $file_string\n" ;
      set_time_limit(60) ; // keep resetting the execution time limit
			
      echo "<!-- ";echo "Get header for $file_string";echo " -->\n" ;
			
		  $cache[$servername]["events"][$filename] = get_file_event($file_string) ;
			if ($extended_desc_log)
			{
			 if (is_array($cache[$servername]["events"][$filename])) { fwrite($fp,date("Ymd H:i:s")." Cache added for $servername"."$filename".PHP_EOL) ; }
			 else                                                    { fwrite($fp,date("Ymd H:i:s")." Cache failed for $servername"."$filename".PHP_EOL) ; }
			}
			//if ($FTPtype[$servername]=="ftpd-topfield") { sleep(1) ; }
		 
		  if ( time() > ($t_start + $time_limit) ) { break ; } // break out of the loop if the time is up
	  } // end of filelist loop
		
		echo "<!-- ";echo "Completed build for $servername (time used ".(time()-$t_start);echo " -->\n" ;
		ini_set("display_errors",0) ;
		$x=file_get_contents($test_string) ; // Now read the test file back (to clean up any hanging processes)
		ini_set("display_errors",1) ;
		
		// Now remove the cache entry for any deleted files
		foreach ($cache[$servername]["events"] as $filename => $event)
		{
		 if (array_key_exists($filename,$extended_list)) { continue ; }
		 unset($cache[$servername]["events"][$filename]) ;
		 if ($extended_desc_log) { fwrite($fp,date("Ymd H:i:s")." Cache deleted for $servername"."$filename".PHP_EOL) ; }
		}
	 
	  //$cache[$servername] = $server_cache ;
		file_put_contents($local_files.DIRECTORY_SEPARATOR.$servername."_extended_cache",serialize($cache[$servername])) ;
    echo "<!-- ";echo "Saved build for $servername (time used ".(time()-$t_start);echo " -->\n" ;
	  if ( time() > ($t_start + $time_limit) ) { break ; }  // break out of the server loop also
 }  // end of server loop
 
 //fwrite($fp,"".date("Ymd H:i:s")." Cache run ended".PHP_EOL.PHP_EOL) ;
 if ($extended_desc_log) { fclose($fp) ; } 
 ini_set("display_errors",$display_status) ;
 return $cache ;
}  // end of function tfheader_build_cache()


//
//
//
//
//function decode_file_header($filename)
function get_file_event($filename)
{ 
 
 ini_set("display_errors",0) ; 
 $header="" ;
 $t1 = microtime();
 if ($fp = fopen($filename, "rb"))
 {
  while (!feof($fp))
  {
   $header .= fread($fp, 2048) ;
	 if (strlen($header)>2000) { break ; }
  }	
  fclose($fp) ;
 }
 $t2 = microtime() ; 
 ini_set("display_errors",1) ; 
 
 if (strlen($header)<2000) { return false ; }
  
 
 //hexdump($header,1024) ;
 
 
 $p = 0 ;
 $size = 14 ;
 $tRECHeader = substr($header,$p,$size) ;
 $p += $size ;
 //echo "\n------ tRECHeader($size) ------\n" ;
 //echo "MagicNumber=".bin2hex(substr($tRECHeader,0,4))."\n" ;
 $version=bin2hex(substr($tRECHeader,4,2)) ;
 //echo "Version=$Version\n" ;
 $RecordingDuration=value("n",substr($tRECHeader,8,2)) ;
 //echo "Duration=$RecordingDuration\n" ;
 //echo "ServiceNR=".value("n",substr($tRECHeader,10,2))."\n" ;
 //echo "ServiceType=".value("n",substr($tRECHeader,12,2))."\n" ;
 
 if("$version"=="5000") { $size=38; }
 else                   { $size=42; }
 $tRECServiceInfo = substr($header,$p,$size) ;
 $p += $size ;
 //echo "\n------ tRECServiceInfo$version($size) -----\n" ;
 //echo "TunerInfo=".ord(substr($tRECServiceInfo,0,1))."\n" ;
 //echo "TunerInfo=".bin2hex(substr($tRECServiceInfo,0,1))."\n" ;
 //echo "ServiceID=".bin2hex(substr($tRECServiceInfo,4,2))."\n" ;
 //echo "ServiceID=".value("n",substr($tRECServiceInfo,4,2))."\n" ;
 //echo "PMTPID=".value("n",substr($tRECServiceInfo,6,2))."\n" ;
 //echo "PCRPID=".value("n",substr($tRECServiceInfo,8,2))."\n" ;
 //echo "VideoPID=".value("n",substr($tRECServiceInfo,10,2))."\n" ;
 //echo "AudioPID=".(value("n",substr($tRECServiceInfo,12,2))%1024)."\n" ;
 $ServiceName = substr($tRECServiceInfo,14) ;
 $ServiceName = substr($ServiceName,0,strcspn($ServiceName,chr(0))) ;
 //echo "ServiceName=$ServiceName\n" ;
 
 $size = 16 ;
 $tRECTPInfo = substr($header,$p,$size) ;
 $p += $size ;
 //echo "\n------ tRECTPInfo -----\n" ;
 //echo "ChannelNumber=".value("n",substr($tRECTPInfo,0,2))."\n" ;
 //echo "Bandwidth=".ord(substr($tRECTPInfo,2,1))."\n" ;
 //echo "Frequency=".value("N",substr($tRECTPInfo,4,4))."\n" ;
 //echo "TSID=".value("n",substr($tRECTPInfo,8,2))."\n" ;
 //echo "LPHPStream=".ord(substr($tRECTPInfo,10,1))."\n" ;
 //echo "NetworkID=".value("n",substr($tRECTPInfo,12,2))."\n" ;
 
 $size = 294 ;
 $tRECEventInfo = substr($header,$p,$size) ;
 $p += $size ;
 //echo "\n------ tRECEventInfo($size) -----\n" ;
 $EventDurationHour=ord(substr($tRECEventInfo,2,1)) ;
 $EventDurationMin=ord(substr($tRECEventInfo,3,1)) ;
 //echo "DurationHour=$EventDurationHour\n" ;
 //echo "DurationMin=$EventurationMin\n" ;
 $EventDuration = ($EventDurationHour*60)+$EventDurationMin ;
 //echo "EventID=".value("N",substr($tRECEventInfo,4,4))."\n" ;
 $StartTimeMJD=value("n",substr($tRECEventInfo,8,2)) ;
 $StartTimeHour=ord(substr($tRECEventInfo,10,1)) ;
 $StartTimeMin=ord(substr($tRECEventInfo,11,1)) ;
 $EndTimeMJD=value("n",substr($tRECEventInfo,12,2)) ;
 $EndTimeHour=ord(substr($tRECEventInfo,14,1)) ;
 $EndTimeMin=ord(substr($tRECEventInfo,15,1)) ;
 //echo "StartTimeMJD=$StartTimeMJD\n" ;
 //echo "StartTimeHour=$StartTimeHour\n" ;
 //echo "StartTimeMin=$StartTimeMin\n" ;
 //echo "EndTimeMJD=$EndTimeMJD\n" ;
 //echo "EndTimeHour=$EndTimeHour\n" ;
 //echo "EndTimeMin=$EndTimeMin\n" ;
 $TextLength=ord(substr($tRECEventInfo,17,1)) ;
 //echo "TextLength=$TextLength\n" ;
 //echo "ParentalRate=".ord(substr($tRECEventInfo,18,1))."\n" ;
 $EventName=substr($tRECEventInfo,19,$TextLength) ;
 //echo "EventName=$EventName\n" ;
 $EventDescription = substr($tRECEventInfo,19+$TextLength) ;
 $EventDescription = substr($EventDescription,0,strcspn($EventDescription,chr(0))) ;
 //echo "EventDescription=$EventDescription\n" ;
 
 $size = 1030 ;
 $tRECExtendedEventInfo = substr($header,$p,$size) ;
 $p += $size ;
 //echo "\n------ tRECExtendedEventInfo($size) -----\n" ;
 $ExtendedTextLength=value("n",substr($tRECExtendedEventInfo,0,2)) ;
 //echo "TextLength=$ExtendedTextLength\n" ;
 //echo "EventID=".value("N",substr($tRECExtendedEventInfo,2,4))."\n" ;
 $ExtendedText = substr($tRECExtendedEventInfo,6,$ExtendedTextLength) ;
 //echo "ExtendedText=$ExtendedText\n" ;
 
 
 $StartDate = date("h:ia D, d M Y",( $StartTime = ((((($StartTimeMJD-40587)*24)+$StartTimeHour)*60)+$StartTimeMin)*60 )) ;
 $EndDate  = date("h:ia D, d M Y", ($EndTime =    ((((($EndTimeMJD  -40587)*24)+$EndTimeHour)  *60)+$EndTimeMin)  *60 )) ;
 //echo "\n------ Event summary -----\n" ;
 //echo "ServiceName=$ServiceName\n\n" ;
 //echo "StartDate=$StartDate\n" ;
 //echo "EndDate=$EndDate\n" ;
 //echo "EventDuration=$EventDuration minutes\n" ;
 //echo "EventName=$EventName\n" ;
 //echo "EventDescription=$EventDescription\n" ;
 //echo "ExtendedText=$ExtendedText\n\n" ;
 //echo "RecordingDuration=$RecordingDuration minutes\n" ;

 $t3=microtime() ;
 
 $event = array() ;
 $event["CacheTime"]         = time() ;  // remember when the header info was read
 $event["ServiceName"]       = $ServiceName ;
 $event["StartTime"]         = $StartTime ;
 $event["EndTime"]           = $EndTime ;
 $event["StartDate"]         = $StartDate ;
 $event["EndDate"]           = $EndDate ;
 $event["EventDuration"]     = $EventDuration ;
 $event["EventName"]         = $EventName ;
 $event["EventDescription"]  = $EventDescription ;
 $event["ExtendedText"]      = $ExtendedText ;
 $event["RecordingDuration"] = $RecordingDuration ;
 $event["microtime"]         = $t2-$t1 ;
 
 //echo "<!-- $EventName  Start=($StartTimeMJD)$StartTimeHour;$StartTimeMin End=($EndTimeMJD)$EndTimeHour;$EndTimeMin-->\n" ;
 
 return $event ;
}
 
 function value($format,$string)
 {
  //echo "Hex=".bin2hex($string)."\n" ;
  $a = unpack($format,$string) ;
	//print_r($a) ;
	return $a[1] ;
 }

 
 function hexdump($s,$len=4096)
 {
  for($i=0;$i<$len;$i+=16)
	{
	 $s2 = substr($s,$i,16) ;
 	 $s3 = preg_replace('/[^a-z0-9.{}()%$@~!+=&,;\'\^\[\]\#\- _]/i', '.', $s2) ;
	 $h2 = "" ;
	 for($j=0;$j<16;$j+=2)
	 {
	  $s4 = substr($s2,$j,2) ;
		$h4 = sprintf("%+04X",$s4) ;
		$h4 = bin2hex($s4) ;
	  $h2 .= "$h4 " ;
	 }
	 echo sprintf("%08X",$i)."h : $h2 ; $s3\n" ;
	}
 }
 
 function get_extended_event($cache,$servername,$foldername,$filename)
 {
  //echo "File=$servername $foldername/$filename\n" ;
  if (is_array($cache[$servername]["events"][$foldername."/".$filename]))
	{
	 //print_r($cache[$servername]["events"][$foldername."/".$filename]) ;
	 return $cache[$servername]["events"][$foldername."/".$filename] ;
	}
	else
	{
	 return false ;
	}
 }

?>
